﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NeuralNumberNetwork {
     abstract class NeuralNetwork {

        private List<Neuron> _InputNeurons = new List<Neuron>();
        public List<Neuron> InputNeurons { get { return _InputNeurons; } }


        private List<Neuron> _ResultNeurons = new List<Neuron>();
        public List<Neuron> ResultNeurons { get { return _ResultNeurons; } }

        public abstract void InitializeInputNeurons(Object inputData);

        public abstract void IntializeHiddenLayers();

        public abstract void IntializeResultNeurons();

        public Neuron runNetwork() {
            Neuron result = new Neuron() {Activation = 0 };
            for (int i = 0; i < ResultNeurons.Count; i++) {
                double neuronResult = ResultNeurons[i].EvaluateActivation();
                if (neuronResult > result.Activation) {
                    result = ResultNeurons[i];
                }
            }
            return result;
        }

        public double evaluateFailure(int indexExpectedResult) {
            double sqaureSum = 0;
            for (int i = 0; i < ResultNeurons.Count; i++) {
                if (i == indexExpectedResult) {
                    sqaureSum += Math.Pow(1 - ResultNeurons[i].Activation, 2);
                } else {
                    sqaureSum += Math.Pow(0 - ResultNeurons[i].Activation, 2);
                }

            }

            return sqaureSum;
        }

    }
}
